#ifndef CUDA_CODE_H
#define CUDA_CODE_H

// includes, system
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

//Cuda includes
#include <builtin_types.h>

typedef struct __builtin_align__(4)
{
  double x, y, z;
} double3;

#define DEFAULT_NPIPES 16384



#ifdef __cplusplus
extern "C" {
#endif

void initCUDA(int blocks, int threads, int n);

void sendToCUDAGPU(int *index, double3 *x, double3 *v, double *mass, int n);

//void startCUDAPredictor(double *ti);
void startCUDAPredictor(double *ti,float *dtj, int *index, float *tj, float *mass, float3 *k18,
                  float3 *j6, float3 *a2, float3 *x, float3 *v, int numberInBuffer);

void calculateCUDAForces(float eps2, int *index, int nj, int ni, double xi[][3], double vi[][3], double h2[]);

int readBackCUDAResults(int nj, int ni, int index[],double acc[][3], double jerk[][3], double pot[], int nnbindex[]);

int calculateNeighbours(double *h2, int blockSize);

int getNeighbour(int *pipe, int *max_length,int *nblen, int nbl[]);


void cleanUpCUDA();

#ifdef __cplusplus
}
#endif  // #ifdef _DEBUG (else branch)




#endif

