#include "grape6_gpu.h"
#include "cudaCode.h"

//Todo dit echt goed maken
int totalNumberOfParticles;
#include "starlab_vector.h"

//#define NMAX 1024*128

/*
typedef struct __builtin_align__(4)
{
  double x, y, z;
} double3;*/

static int currentMemorySize = 2048;
static bool firstTiCall = true;

/*int mem_size_float4;
unsigned int mem_size_float3;
unsigned int mem_size_float;
unsigned int mem_size_int ;*/

static int mem_size_float4   = sizeof(float4) *  currentMemorySize;
static int mem_size_float3   = sizeof(float3) *  currentMemorySize;
static int mem_size_float    = sizeof(float)  *  currentMemorySize;
static int mem_size_int      = sizeof(int)    *  currentMemorySize;


static unsigned int mem_size_double3   = sizeof(double3) *  currentMemorySize;
static unsigned int mem_size_double    = sizeof(double)  *  currentMemorySize;


//Using floats for the moment, since doubles wont be available for an other year

double   *localDtj;
double   *localAddress; //niet nodig denk ik
int     *localIndex;
double   *localTj;
double  *localMass;
double3  *localK18;
double3  *localJ6;
double3  *localA2;
double3  *localX;
double3  *localV;
double *localH2;

double3  *localXPred;
double3  *localVPred;

//Buffers to store the x and v values of partciles that
//are used by the firsthalf functions
double (*xIn)[3];
double (*vIn)[3];

double lastMinTi = 0;
int lastNiValue;


///  LIBRARY CONTROL VARIABLES  ////
bool dataSetInBuffer            = false;
int  numberOfParticlesInBuffer  = 0;
int  maxNumberOfParticles       = 0;

//// Internal Library Function headers
void sendLocalBuffer(double *ti);

//Local arrays used to convert double[3] to vector
double (*accLocal)[3];
double (*jerkLocal)[3];

//// LIBRARY FUNCTIONS


int 	GPU_g6_reset_ (int *cluster_id)
{ 
  //Can't reset GPU so just return 1
  return 1;
}
void  GPU_g6_set_overflow_flag_test_mode(int aflag, int jflag, int pflag){}
int 	GPU_g6_reset_fofpga_ (int *cluster_id)
{ 
  //Can't reset GPU so just return 1
  return 1;
}
void GPU_g6_initialize_jp_buffer(int clusterid, int size)
{
}

void  GPU_g6_initialize_jp_buffer_(int *clusterid, int *size)
{
}
void  GPU_g6_flush_jp_buffer_(int *clusterid)
{
}

int GPU_g6_print_chip_status(int clusterid)
{
  return 0;
}

int GPU_g6_reinitialize(int clusterid)
{
  return 0;
}

int GPU_g6_flush_jp_buffer_and_multisend(int clusterid, int clusters)
{
  return 0;
}

///   GRAPE 6 functions
//Initialize the CUDA environment
int GPU_g6_open_(int *clusterid)
{
  //Buffers have max the size of the number of pipes
  int tempSize = GPU_g6_npipes_();


  //Allocate memory for the various buffers
  xIn       = (double(*)[3]) malloc(tempSize*sizeof(double)*3);
  vIn       = (double(*)[3]) malloc(tempSize*sizeof(double)*3);

  accLocal  = (double(*)[3]) malloc(tempSize*sizeof(double)*3);
  jerkLocal = (double(*)[3]) malloc(tempSize*sizeof(double)*3);

  //Allocate initial memory for local buffers
  localDtj     = (double*) malloc(mem_size_double);
  localAddress = (double*) malloc(mem_size_double);
  localIndex   = (int*)    malloc(mem_size_int);
  localTj      = (double*) malloc(mem_size_double);
  localMass    = (double*) malloc(mem_size_double);

  localK18     = (double3*) malloc(mem_size_double3);
  localJ6      = (double3*) malloc(mem_size_double3);
  localA2      = (double3*) malloc(mem_size_double3);
  localX       = (double3*) malloc(mem_size_double3);
  localV       = (double3*) malloc(mem_size_double3);

  localXPred   = (double3*) malloc(mem_size_double3);
  localVPred   = (double3*) malloc(mem_size_double3);

  //Create memory for the neighbourhoud radius
 // localH2  = (double*) malloc(tempSize * sizeof(double));

  return 1;
}

//Close and clean up CUDA environment
int GPU_g6_close_(int *clusterid)
{
  //Free up all reserved library memory
  cleanUpCUDA();

  firstTiCall = true;

  //Free up local memory
  free(localDtj);
  free(localAddress);
  free(localIndex);
  free(localTj);
  free(localMass);
  free(localK18);
  free(localJ6);
  free(localA2);
  free(localX);
  free(localV);
  free(localXPred);
  free(localVPred);
  free(localH2);

  free(accLocal);
  free(jerkLocal);

  free(xIn);
  free(vIn);

  return 1;
}



void  GPU_g6_set_tunit_(int *newtunit){}
void  GPU_g6_set_xunit_(int *newxunit){}

//Should return the maximum number of threads/particles we can execute 
int GPU_g6_npipes_()
{
  //Number of npipes can be configured by the user to improve performance
  //of codes that use npipes value for loop indexes. 
  FILE   *inp = fopen("kirin.cfg","r");
  if(inp != NULL)
  {
    int temp;    
    fscanf(inp,"%d",&temp);
    fclose(inp);

    return temp;
  } 

  //No configuration file, take default value
  return DEFAULT_NPIPES;
}


int GPU_g6_set_j_particle_multisend_mxfast_(int * clusterid,
                                 int * nclusters,
                                 int *address,
                                 int *index,
                                 double *mass,
                                 double x[3] /* position */)
{
  double v[3] = {0,0,0};
  double tj = 0; 
  double dtj = 0;
  double k18[3] = {0,0,0};
  double j6[3] = {0,0,0};
  double a2[3] = {0,0,0};
   
  //Call the usual set_j_particle function with 0's for the v value
  return GPU_g6_set_j_particle_(clusterid, address, index, &tj, &dtj, mass, k18,j6,a2,v,x);
}


//Sets a particle in grape6 memory  / local buffer
int GPU_g6_set_j_particle_(int *cluster_id, int *address, int *index, double *tj,
                          double *dtj, double *mass, double k18[3], double j6[3],
                          double a2[3], double v[3], double x[3])
{ 
  //These must all be the arrays of size three. tj, dtj and mass are the time, timestep and mass of the particle.
  //address is the location in the GRAPE-6 memory to store the particle, starting from index 0, 
  //and index is the identifier for the particle itself, which may be different from address above.

  //Its inefficient to send data particles one by one so cache them locally and send them in one batch.

  dataSetInBuffer = true;
  numberOfParticlesInBuffer++;

  //See if we have to increase the ammount of memory
  if(numberOfParticlesInBuffer > currentMemorySize)
  {
    //We double the buffer size
    currentMemorySize *= 2;

    //Update the memory sizes
    mem_size_float4   = sizeof(float4) *  currentMemorySize;
    mem_size_float3   = sizeof(float3) *  currentMemorySize;
    mem_size_float    = sizeof(float)  *  currentMemorySize;
    mem_size_int      = sizeof(int)    *  currentMemorySize;

    mem_size_double3  = sizeof(double3) * currentMemorySize;
    mem_size_double   = sizeof(double)  * currentMemorySize;
  
    //Reallocate the  buffers so they have double the size then before
    localDtj     = (double*) realloc(localDtj,      mem_size_double);
    localAddress = (double*) realloc(localAddress,  mem_size_double);
    localIndex   = (int*)    realloc(localIndex,    mem_size_int);
    localTj      = (double*) realloc(localTj,       mem_size_double);
    localMass    = (double*) realloc(localMass,     mem_size_double);
    
    localK18     = (double3*) realloc(localK18, mem_size_double3);
    localJ6      = (double3*) realloc(localJ6,  mem_size_double3);
    localA2      = (double3*) realloc(localA2,  mem_size_double3);
    localX       = (double3*) realloc(localX,   mem_size_double3);
    localV       = (double3*) realloc(localV,   mem_size_double3);

    localXPred   = (double3*) realloc(localXPred, mem_size_double3);
    localVPred   = (double3*) realloc(localVPred, mem_size_double3);
  }

  //Copy the various values in the local buffers
  localIndex[*address]  = *index;
  localTj[*address]     = *tj;
  localDtj[*address]    = *dtj;
  localMass[*address]   = *mass;
  
  localK18[*address].x  =  k18[0];
  localJ6[*address].x   =  j6[0];
  localA2[*address].x   =  a2[0];
  localX[*address].x    =  x[0];
  localV[*address].x    =  v[0];
 
  localK18[*address].y  =  k18[1];
  localJ6[*address].y   =  j6[1];
  localA2[*address].y   =  a2[1];
  localX[*address].y    =  x[1];
  localV[*address].y    =  v[1];

  localK18[*address].z  =  k18[2];
  localJ6[*address].z   =  j6[2];
  localA2[*address].z   =  a2[2];
  localX[*address].z    =  x[2];
  localV[*address].z    =  v[2];

  //0 if succes
  return 0; //TODO:Should check if malloc/realloc failed...
}

// Sets the current time on the GPU and starts the predictor
void 	GPU_g6_set_ti_ (int *cluster_id, double *min_t)
{
  //Here we predict the particles, this is done on the CPU to be able to do it 
  //in double precision.

  lastMinTi = *min_t;

  //if this is the first call it is time to initialize CUDA since we know
  //the number of particles
  if(firstTiCall)
  {
    maxNumberOfParticles    = numberOfParticlesInBuffer;
    totalNumberOfParticles  = numberOfParticlesInBuffer;
    firstTiCall = false;
    initCUDA(1,1,totalNumberOfParticles);
  }

  //When new particles are created we have to increase
  //the allocated memory on the GPU.
  if(numberOfParticlesInBuffer > totalNumberOfParticles)
  {
    totalNumberOfParticles = numberOfParticlesInBuffer;

    //Only reinitialize if there are more stars then ever before
    //It can happen that a binarie is created and some steps later split again. 
    //Since we already have enough memory then there is no need to increase it more
    if(totalNumberOfParticles > maxNumberOfParticles)
    {  
      maxNumberOfParticles = totalNumberOfParticles;
      //Free up all reserved library memory
      cleanUpCUDA();
      //Reinitialize all memory spaces etc
      initCUDA(1,1,totalNumberOfParticles);
     }  
  }
  
  //Predict particles on the cpu
  double dt_tmp, dt2half, dt3over6;

  for(int i=0; i<totalNumberOfParticles; i++)
  {     	
    dt_tmp    = *min_t - localTj[i];
    dt2half   = dt_tmp*dt_tmp;
    dt3over6  = dt_tmp*dt2half;

    //TODO de k18 term toevoegen
    localXPred[i].x = localX[i].x + localV[i].x*dt_tmp + localA2[i].x*dt2half + localJ6[i].x*dt3over6;
    localXPred[i].y = localX[i].y + localV[i].y*dt_tmp + localA2[i].y*dt2half + localJ6[i].y*dt3over6;
    localXPred[i].z = localX[i].z + localV[i].z*dt_tmp + localA2[i].z*dt2half + localJ6[i].z*dt3over6;

    ////Multiply localA2 by 2 and localJ6 by 3, to get original values 
    localVPred[i].x = localV[i].x + localA2[i].x*dt_tmp*2 + localJ6[i].x*dt2half*3;         
    localVPred[i].y = localV[i].y + localA2[i].y*dt_tmp*2 + localJ6[i].y*dt2half*3;  
    localVPred[i].z = localV[i].z + localA2[i].z*dt_tmp*2 + localJ6[i].z*dt2half*3;      
  }

  //Send the predicted particles to the GPU code
  sendLocalBuffer(min_t);
}


void 	GPU_g6calc_firsthalf_ (int *cluster_id, int *nj, int *ni, int index[], double xi[][3], double vi[][3], double aold[][3], double j6old[][3], double phiold[], double *eps2, double h2[])
{ 
  //See if we have to change the number of particles in the system
  //if so call set_ti to reinitialize the GPU.
  if(*nj != totalNumberOfParticles)
  {
    totalNumberOfParticles = *nj;
    GPU_g6_set_ti_(0, &lastMinTi);
  }
  
  //Start the force calculation
  lastNiValue = *ni;
  calculateCUDAForces((float)*eps2, index, *nj, *ni, xi, vi,h2);
}

int 	GPU_g6calc_lasthalf_ (int *cluster_id, int *nj, int *ni, int index[], double xi[][3], double vi[][3], double *eps2, double h2[], double acc[][3], double jerk[][3], double pot[])
{
  //Read back the results
  readBackCUDAResults(*nj, *ni,index,acc,jerk,pot, NULL);

  return 0;
}

//Firsthalf function with vector types for Starlab support
void GPU2_g6calc_firsthalf_(int *cluster_id,int *nj,int *ni,int index[],vec xi[],vec vi[],vec aold[],vec j6old[],double phiold[],double *eps2,double h2[])
{
  //See if we have to change the number of particles in the system
  if(*nj != totalNumberOfParticles)
  {
    totalNumberOfParticles = *nj;
    GPU_g6_set_ti_(0, &lastMinTi);
  }

  //Convert the vectors into arrays
  for(int i=0; i < *ni; i++)
  {
    xIn[i][0] = xi[i][0]; xIn[i][1] = xi[i][1]; xIn[i][2] = xi[i][2];
    vIn[i][0] = vi[i][0]; vIn[i][1] = vi[i][1]; vIn[i][2] = vi[i][2];
  }
    
  lastNiValue = *ni;
  calculateCUDAForces((float)*eps2, index, *nj, *ni,xIn,vIn,h2);
 
}

//lasthalf function with vector types for Starlab support
int GPU2_g6calc_lasthalf2_(int *cluster_id,
				 int *nj,
				 int *ni,
				 int index[],
				 vec xi[],		// double xi[][3],
				 vec vi[],		// double vi[][3],
				 double *eps2,
				 double h2[],
				 vec acc[],		// double acc[][3],
				 vec jerk[],		// double jerk[][3],
				 double pot[],
				 int nnbindex[])
{
  //Get results from the GPU
  readBackCUDAResults(*nj, *ni,index,accLocal,jerkLocal,pot, nnbindex);

  //Put the arrays back in the vectors
  for(int i=0; i < *ni; i++)
  {
    for(int k=0; k < 3;k++)
    {
      acc[i][k]  = accLocal[i][k];
      jerk[i][k] = jerkLocal[i][k];
    }
  }

  return 0;
}



int 	GPU_g6_read_neighbour_list_ (int *cluster_id)
{
  /*
  Return value of zero means successful completion,
  -1 some internal error and 1 overflow of the hardware neighbour list memory

  Since we want to know the neighbours we have to do the calculation again using
  the neighbourhood kernel

  This is called right after a previous calculation so x, index, etc are already loaded 
  to the GPU, now we only have to send H2 since this was not set. 
  */
  calculateNeighbours(localH2,lastNiValue);

  return 0;
}

int 	GPU_g6_get_neighbour_list_ (int *cluster_id,int *pipe, int *max_length,
                                  int *nblen, int nbl[])
{
  //This function extracts the actual neighbor list of particle 
  //calculated for particle ipipe from the working memory of the interface library
  //prepared by g6_read_neighbour_list. The argument maxlength gives the size
  //of the array nbl. Return value of zero means successful completion and 1 overflow. 
  //On successful return, nblen has the length of the neighbour list and nbl actual list
  //(sorted by the indices).

  return getNeighbour(pipe, max_length,nblen,nbl);
}


///LIBRARY FUNCTIONS
void sendLocalBuffer(double *ti)
{  
  //Send the data to the gpu
   //TODO
  //For now I just send the _complete_ buffer over, later on it can be refined
  //to only send and update the values that did actually change.

   sendToCUDAGPU(localIndex,localXPred, localVPred, localMass,totalNumberOfParticles);

  numberOfParticlesInBuffer = 0;
  dataSetInBuffer           = false;
}



int   GPU_g6_close(int clusterid)
{
  return GPU_g6_close_(&clusterid);
}
int   GPU_g6_open(int clusterid)
{
  return GPU_g6_open_(&clusterid);
}
int   GPU_g6_npipes()
{
    return GPU_g6_npipes_();
}
void 	GPU_g6_set_ti(int cluster_id, double ti)
{
  GPU_g6_set_ti_(&cluster_id, &ti);
}
int 	GPU_g6_reset(int cluster_id)
{
  return GPU_g6_reset_(&cluster_id);
}
int 	GPU_g6_reset_fofpga(int cluster_id)
{
  return GPU_g6_reset_fofpga_(&cluster_id);
}
int 	GPU_g6_set_j_particle(int clusterid, int address, int index, double tj, double dtj, double mass, double k18[3], double j6[3], double a2[3], double v[3], double x[3])
{  
  return GPU_g6_set_j_particle_(&clusterid, &address,&index,&tj,&dtj,&mass,k18,j6,a2,v,x);
}
void 	GPU_g6calc_firsthalf(int cluster_id, int nj, int ni, int index[], double xi[][3], double vi[][3], double aold[][3], double j6old[][3], double phiold[], double eps2, double h2[])
{     
  GPU_g6calc_firsthalf_ (&cluster_id, &nj, &ni, index, xi, vi, aold, j6old, phiold, &eps2,h2);
}
int 	GPU_g6calc_lasthalf(int cluster_id, int nj, int ni, int index[], double xi[][3], double vi[][3], double eps2, double h2[], double acc[][3], double jerk[][3], double pot[])
{ 
  return GPU_g6calc_lasthalf_ (&cluster_id, &nj, &ni, index, xi, vi, &eps2, h2, acc, jerk, pot);  
}
void  GPU_g6_set_tunit(int newtunit)
{
  GPU_g6_set_tunit_(&newtunit);
}
void  GPU_g6_set_xunit(int newxunit)
{
  GPU_g6_set_xunit_(&newxunit);
}

