//Grape6.h , grape 6 header file 
//Used for GPU
#ifndef GRAPE6_H
#define GRAPE6_H

#include <stdio.h>
#include "starlab_vector.h"

#ifdef __cplusplus
extern "C" {
#endif
//Functions without at the end....
int   g6_close(int clusterid);
int   g6_open(int clusterid);
int   g6_npipes();
int   g6_open(int clusterid);
void 	g6_set_ti(int cluster_id, double ti);
void  g6_initialize_jp_buffer(int clusterid, int size);
void  g6_flush_jp_buffer(int clusterid);
int 	g6_reset(int cluster_id) ;
int 	g6_reset_fofpga(int cluster_id);
void  g6_set_neighbour_list_sort_mode(int mode);
int 	g6_set_j_particle(int clusterid, int address, int index, double tj, double dtj, double mass, double k18[3], double j6[3], double a2[3], double v[3], double x[3]);
void 	g6calc_firsthalf(int cluster_id, int nj, int ni, int index[], double xi[][3], double vi[][3], double aold[][3], double j6old[][3], double phiold[], double eps2, double h2[]);
int 	g6calc_lasthalf(int cluster_id, int nj, int ni, int index[], double xi[][3], double vi[][3], double eps2, double h2[], double acc[][3], double jerk[][3], double pot[]);
void  g6_set_tunit(int newtunit);
void  g6_set_xunit(int newxunit);



int   g6_open_(int *clusterid);
int   g6_close_(int *clusterid);
int   g6_npipes_();
void 	g6_set_ti_ (int *cluster_id, double *ti);
int 	g6_reset_ (int *cluster_id);
int 	g6_reset_fofpga_ (int *cluster_id);

void  g6_set_tunit_(int *newtunit);
void  g6_set_xunit_(int *newxunit);



void  g6_set_overflow_flag_test_mode(int aflag, int jflag, int pflag);

//AMD DMA 
void  g6_initialize_jp_buffer_(int *clusterid, int *size);
void  g6_flush_jp_buffer_(int *clusterid);

int 	g6_set_j_particle_(int *clusterid, int *address, int *index, double *tj, double *dtj, double *mass, double k18[3], double j6[3], double a2[3], double v[3], double x[3]);
void 	g6calc_firsthalf_ (int *cluster_id, int *nj, int *ni, int index[], double xi[][3], double vi[][3], double aold[][3], double j6old[][3], double phiold[], double *eps2, double h2[]);
int 	g6calc_lasthalf_ (int *cluster_id, int *nj, int *ni, int index[], double xi[][3], double vi[][3], double *eps2, double h2[], double acc[][3], double jerk[][3], double pot[]);


void GPU_g6calc_firsthalf_(int *cluster_id,
				  int *nj,
				  int *ni,
				  int index[],
				  vec xi[],		// double xi[][3],
				  vec vi[],		// double vi[][3],
				  vec aold[],	// double acc[][3],
				  vec j6old[],	// double jerk[][3],
				  double phiold[],
				  double *eps2,
				  double h2[]);

int GPU_g6calc_lasthalf_(int *cluster_id,
				int *nj,
				int *ni,
				int index[],
				vec xi[],		// double xi[][3],
				vec vi[],		// double vi[][3],
				double *eps2,
				double h2[],
				vec acc[],		// double acc[][3],
				vec jerk[],		// double jerk[][3],
				double pot[]);

int GPU_g6calc_lasthalf2_(int *cluster_id,
				 int *nj,
				 int *ni,
				 int index[],
				 vec xi[],		// double xi[][3],
				 vec vi[],		// double vi[][3],
				 double *eps2,
				 double h2[],
				 vec acc[],		// double acc[][3],
				 vec jerk[],		// double jerk[][3],
				 double pot[],
				 int nnbindex[]);


#ifdef __cplusplus
}
#endif  // #ifdef _DEBUG (else branch)


#endif



/*
* void 	g6_set_tunit_ (int *new_tunit)
* void 	g6_set_xunit_ (int *new_xunit)
* int 	g6_open_ (int *cluster_id)
* int 	g6_close_ (int *cluster_id)
* int 	g6_reset_ (int *cluster_id)
* int 	g6_reset_fofpga_ (int *cluster_id)
* int 	g6_npipes_ ()
* void 	g6_set_ti_ (int *cluster_id, double *ti)
* int 	g6_set_j_particle_ (int *cluster_id, int *address, int *index, double *tj, double *dtj, double *mass, double k18[3], double j6[3], double a2[3], double v[3], double x[3])
* void 	g6calc_firsthalf_ (int *cluster_id, int *nj, int *ni, int index[], vec xi[], vec vi[], vec aold[], vec j6old[], double phiold[], double *eps2, double h2[])
int 	g6calc_lasthalf_ (int *cluster_id, int *nj, int *ni, int index[], vec xi[], vec vi[], double *eps2, double h2[], vec acc[], vec jerk[], double pot[])
int 	g6calc_lasthalf2_ (int *cluster_id, int *nj, int *ni, int index[], vec xi[], vec vi[], double *eps2, double h2[], vec acc[], vec jerk[], double pot[], int nnbindex[])
int 	g6_read_neighbour_list_ (int *cluster_id)
int 	g6_read_neighbour_list_old_ (int *cluster_id)
int 	g6_get_neighbour_list_ (int *cluster_id, int *pipe, int *max_length, int *nblen, int nbl[])
* int 	g6_initialize_jp_buffer_ (int *clusterid, int *size)
* int 	g6_flush_jp_buffer_ (int *clusterid)
*/