//Grape6.h , grape 6 header file 
//Used for GPU
#ifndef GRAPE6_H
#define GRAPE6_H

#include <stdio.h>
#include "starlab_vector.h"

#ifdef __cplusplus
extern "C" {
#endif
//Functions without at the end....
int   GPU_g6_close(int clusterid);
int   GPU_g6_open(int clusterid);
int   GPU_g6_npipes();
int   GPU_g6_open(int clusterid);
void 	GPU_g6_set_ti(int cluster_id, double ti);
void  GPU_g6_initialize_jp_buffer(int clusterid, int size);
void  GPU_g6_flush_jp_buffer(int clusterid);
int 	GPU_g6_reset(int cluster_id) ;
int 	GPU_g6_reset_fofpga(int cluster_id);
void  GPU_g6_set_neighbour_list_sort_mode(int mode);
int 	GPU_g6_set_j_particle(int clusterid, int address, int index, double tj, double dtj, double mass, double k18[3], double j6[3], double a2[3], double v[3], double x[3]);
void 	GPU_g6calc_firsthalf(int cluster_id, int nj, int ni, int index[], double xi[][3], double vi[][3], double aold[][3], double j6old[][3], double phiold[], double eps2, double h2[]);
int 	GPU_g6calc_lasthalf(int cluster_id, int nj, int ni, int index[], double xi[][3], double vi[][3], double eps2, double h2[], double acc[][3], double jerk[][3], double pot[]);
void  GPU_g6_set_tunit(int newtunit);
void  GPU_g6_set_xunit(int newxunit);

int GPU_g6_set_j_particle_multisend_mxfast_(int * clusterid,
                                 int * nclusters,
                                 int *address,
                                 int *index,
                                 double *mass,
                                 double x[3] /* position */);

int GPU_g6_flush_jp_buffer_and_multisend(int clusterid, int clusters);

int GPU_g6_print_chip_status(int clusterid);
int GPU_g6_reinitialize(int clusterid);


int   GPU_g6_open_(int *clusterid);
int   GPU_g6_close_(int *clusterid);
int   GPU_g6_npipes_();
void 	GPU_g6_set_ti_ (int *cluster_id, double *ti);
int 	GPU_g6_reset_ (int *cluster_id);
int 	GPU_g6_reset_fofpga_ (int *cluster_id);

void  GPU_g6_set_tunit_(int *newtunit);
void  GPU_g6_set_xunit_(int *newxunit);



void  GPU_g6_set_overflow_flag_test_mode(int aflag, int jflag, int pflag);

//AMD DMA 
void  GPU_g6_initialize_jp_buffer_(int *clusterid, int *size);
void  GPU_g6_flush_jp_buffer_(int *clusterid);

int 	GPU_g6_set_j_particle_(int *clusterid, int *address, int *index, double *tj, double *dtj, double *mass, double k18[3], double j6[3], double a2[3], double v[3], double x[3]);
void 	GPU_g6calc_firsthalf_ (int *cluster_id, int *nj, int *ni, int index[], double xi[][3], double vi[][3], double aold[][3], double j6old[][3], double phiold[], double *eps2, double h2[]);
int 	GPU_g6calc_lasthalf_ (int *cluster_id, int *nj, int *ni, int index[], double xi[][3], double vi[][3], double *eps2, double h2[], double acc[][3], double jerk[][3], double pot[]);


void GPU2_g6calc_firsthalf_(int *cluster_id,
				  int *nj,
				  int *ni,
				  int index[],
				  vec xi[],		// double xi[][3],
				  vec vi[],		// double vi[][3],
				  vec aold[],	// double acc[][3],
				  vec j6old[],	// double jerk[][3],
				  double phiold[],
				  double *eps2,
				  double h2[]);

int GPU2_g6calc_lasthalf_(int *cluster_id,
				int *nj,
				int *ni,
				int index[],
				vec xi[],		// double xi[][3],
				vec vi[],		// double vi[][3],
				double *eps2,
				double h2[],
				vec acc[],		// double acc[][3],
				vec jerk[],		// double jerk[][3],
				double pot[]);

int GPU2_g6calc_lasthalf2_(int *cluster_id,
				 int *nj,
				 int *ni,
				 int index[],
				 vec xi[],		// double xi[][3],
				 vec vi[],		// double vi[][3],
				 double *eps2,
				 double h2[],
				 vec acc[],		// double acc[][3],
				 vec jerk[],		// double jerk[][3],
				 double pot[],
				 int nnbindex[]);

int 	GPU_g6_get_neighbour_list_ (int *cluster_id,int *pipe, int *max_length,
                                  int *nblen, int nbl[]);
int 	GPU_g6_read_neighbour_list_ (int *cluster_id);


#ifdef __cplusplus
}
#endif  // #ifdef __cplusplus


#endif
